# ---(Description)-----------------------------------------------------------
# Mystic Leech v1.0 By Darryl Perry, 2003.  A Cyberia BBS Production
#
# Mystic Leech is a Mystic MPL version of the classic, original BBS online
# game of Leech.
#
# Although this program is entered into the public domain, please give
# credit where credit is due.  If you use this program, or portions thereof,
# plese give due credit.
#
# More informaton can be found in the sysop.txt file of the gy-lch10.zip
# ---------------------------------------------------------------------------

Uses Cfg
Uses Dir
Uses User

Const	ProgName	=	'Mystic Leeh'
Const	ProgVer		=	'v1.0'
Const	ProgAuth	=	'Darryl Perry, 2003'
Const	PlyrFile	=	'leech.ply'
Const	ItemFile	=	'leech.itm'
Const	PIdx		=	1
Const	PName		=	2
Const	PAlias		=	3
Const	PLastOn		=	4
Const	PWeap		=	5
Const	PWeapNo		=	6
Const	PArm		=	7
Const	PArmNo		=	8
Const	PLev		=	9
Const	PHP			=	10
Const	PRuns		=	11
Const	PMoney		=	12
Const	PBank		=	13
Const	PDl			=	14
Const	PRank		=	15
Const	PCalls		=	16
Const	PFights		=	17
Const	PMegs		=	18
Const	PFBu		=	19
Const	PTroj		=	20

Var	F1		String
Var	F2		String
Var	F3		String
Var Istr	String
Var Done	Boolean	
Var	Othr	String Array (1..25)
Var	Plyr	String Array (1..25)
Var	Sane	String Array (1..25)
Var PlyrCnt	Integer
Var PlyrIdx	Integer
Var OthrIdx	Integer
Var GNum	Integer
Var GStr	Integer
Var GPrice	LongInt	
Var GWep	String
Var GArm	String
Var Today	String
Var BF		String
Var SF		String
Var Guf		Integer	
Var I1		Integer
Var I2		Integer
Var I3		Integer
Var I4		Integer
Var I5		Integer
Var I6		Integer
Var Num		Integer
Var Times	Integer
Var Run		Integer

GetCfg
GetThisUser
F1:=CfgDataPath+PlyrFile
F2:=CfgDataPath+ItemFile
BF:='bull.lch'

If ParamCount >= 1 Then
	SF:=ParamStr(1)
Else
	SF:='scores.lch'
Endif

Procedure Paws
Begin
	Write('|CR|PA')
Pend

Procedure ReadBull
Begin
	DispFile(BF)
	If IsNoFile Then
		WriteLn('|CRNo LLL Bulletin Today.')
	Endif
	Paws
Pend

Function IncStr(Str1 string, Amt1 Integer) : String
Begin
	IncStr:=Int2Str(Str2Int(Str1)+Amt1)
Pend

Function DecStr(Str1 string, Amt1 Integer) : String
Begin
	DecStr:=Int2Str(Str2Int(Str1)-Amt1)
Pend

Procedure WriteBull
Var T1	String Array (1..4)
Begin
	WriteLn('|CREnter four lines:')
	For I5:=1 to 4
		Write(': ')
		T1(I5):=Input(75,75,11,'')
	Fend
	If InputYN('|CRIs this okay? ') Then
		fOpen(4,Text,ReWrite,CfgTextPath+BF)
		fWriteLn(4,'LLL Bulletin Announced by: ' + Plyr(PName))
		fWriteLn(4,'')
		For I5:=1 to 4
			fWriteLn(4,T1(I5))
		Fend
		fClose(4)
		WriteLn('|CR|10Bulletin Saved.')
	Else
		WriteLn('|CR|11Nothing Saved.')
	Endif
	Paws
Pend

Procedure LLLBull
Var C1	Char
Begin
	C1:=''
	While C1 <> 'Q'
		CLS
		WriteLn('|CR|11The LLL Bulletin:|CR')
		WriteLn('Options: ')
		WriteLn(' |10[|11L|10] |11Listen to bulletin')
		writeLn(' |10[|11W|10] |11Write Bulletin')
		WriteLn(' |10[|11Q|10] |11Quit')
		Write  ('|CR|11Which (|10L,W,Q|11) : ' )
		C1:=OneKey('LWQ')
		If C1 = 'L'	Then ReadBull	Endif
		If C1 = 'W'	Then WriteBull	Endif
	Wend
Pend

Procedure InitPlyr (PC Integer)
Begin
	For I5:=1 to 25
		Plyr(I5):=''
	Fend
	PlyrIdx:=PC
	Plyr(PIdx):=Int2Str(PlyrIdx)
	Plyr(PName):=UserAlias
	Plyr(PLastOn):=DateStr(DateTime,1)
	Plyr(PWeap):='Dumb Terminal'
	Plyr(PArm):='None'
	Plyr(PWeapNo):='1'
	Plyr(PArmNo):='1'
	Plyr(PLev):='1'
	Plyr(PDl):='10'
	Plyr(PMoney):='10'
	Plyr(PBank):='0'
	Plyr(PRuns):='3'
	Plyr(PCalls):='10'
	Plyr(PFights):='3'
	Plyr(PHp):='10'
	Plyr(PMegs):='10'
	Plyr(PRank):='1'
	Plyr(PTroj):='1'
	Plyr(PFBu):='1'
Pend

Procedure O2S
Begin
	For I4:=1 to 25
		Sane(I4):=Othr(I4)
	Fend
Pend

Procedure S2O
Begin
	For I4:=1 to 25
		Othr(I4):=Sane(I4)
	Fend
Pend

Procedure O2P
Begin
	For I4:=1 to 25
		Plyr(I4):=Othr(I4)
	Fend
Pend

Procedure P2O
Begin
	For I4:=1 to 25
		Othr(I4):=Plyr(I4)
	Fend
Pend

Procedure S2P
Begin
	For I4:=1 to 25
		Plyr(I4):=Sane(I4)
	Fend
Pend

Procedure P2S 
Begin
	For I4:=1 to 25
		Sane(I4):=Plyr(I4)
	Fend
Pend

Procedure ParseItem ( Line String )
Var Front	String
Var Back	String
Var Idx		Integer
Var Cnt		Integer
Begin
	Front:=Line
	Back:=Line
	Cnt:=1
	Repeat
		Idx:=Pos(':',Front)
		If Idx > 0
			Delete(Front,Length(Front)-Idx+1,Idx)
			Delete(Back,Idx,1)
		Endif
		If	   Cnt = 1 Then
			GNum:=Str2Int(Front)
		Elseif Cnt = 2 Then
			GStr:=Str2Int(Front)
		Elseif Cnt = 3 Then
			GPrice:=Str2Int(Front)
		Elseif Cnt = 4 Then
			GWep:=Front
		Elseif Cnt = 5 Then
			GArm:=Front
		Endif
		Front:=Back
		Cnt:=Cnt+1
	Until Idx = 0 
Pend

Function ReadItem(RecNo Integer ) : Integer
Var Ok		Integer
Var Ttxt1	String	
Begin
	Ok:=1
	If fExist(F2) Then
		fOpen(2,Text,Reset,F2)
		I2:=1
		While I2 <= RecNo and not eof(2)
			fReadLn(2,Ttxt1)
			Ok:=1
			I2:=I2+1
		Wend
		fClose(2)
		If I2 = RecNo + 1 then
			ParseItem(Ttxt1)
		Endif
	Endif
	ReadItem:=Ok
Pend

Function ReadSane(RecNo Integer ) : Integer
Var Ok	Integer
Begin
	Ok:=1
	If fExist(F1) Then
		fOpen(1,Text,Reset,F1)
		For I2:=1 to RecNo
			For I1:=1 to 25
				If not eof(1)	
					fReadLn(1,Sane(I1))
				Else
					Ok:=0	
				Endif
			Fend
		Fend	
		fClose(1)
	Else
		Ok:=0
	Endif
	ReadSane:=Ok
Pend

Procedure SaveSane(Recno Integer, Poo Integer)
Var F1a	String
Begin
	F1a:=F1+'.tmp'
	If fExist(F1a) Then	
		fErase(F1a)
	Endif
	fOpen(2,Text,ReWrite,F1a)

	For I2:=1 to PlyrCnt 
		If ReadSane(I2) = 1 Then
			If I2=RecNo Then
				If Poo = 0 Then
					P2S
				Else
					O2S
				Endif
			Endif
		Else
			If RecNo >= I2 Then
				P2S
			Endif
		Endif
		For I3:=1 to 25
			fWriteLn(2,Sane(I3))
		Fend
	Fend
	fClose(2)

	If fExist(F1a) Then
		If fExist(F1)	Then
			fErase(F1)
			If fCopy(F1a,F1) Then
				fErase(F1a)
			Endif
		Else
			If fCopy(F1a,F1) Then
				fErase(F1a)
			Endif
		Endif
	Endif
Pend

Procedure SaveOthr(RecNo Integer)
Begin
	O2S
	SaveSane(RecNo,1)
Pend

Procedure SavePlyr(RecNo Integer)
Begin
	P2S
	SaveSane(RecNo,0)
Pend

Function ReadOthr(RecNo Integer) : Integer
Var X	Integer
Begin
	X:=0
	X:=ReadSane(RecNo)
	S2O
	ReadOthr:=X
Pend

Function ReadPlyr(RecNo Integer) : Integer
Var X	Integer
Begin
	X:=ReadSane(RecNo)
	S2P
	ReadPlyr:=X
Pend

Function Robank3 : String
Var L1 LongInt
Begin
	L1:=0
	For I5:=1 to PlyrCnt
		If ReadOthr(I5)=1 Then
			L1:=L1+Str2Int(Othr(PBank))
			Othr(PBank):='0'
			SaveOthr(I5)
		Endif	
	Fend
	Robank3:=Int2Str(L1)
Pend

Procedure Robank2
Var jkl	Integer
Var jll	Integer
Var t2t	String
Begin
	jkl:=Str2Int(Plyr(PDl))*10
	jkl:=jkl/10
	If Jkl<2 then jkl:=2 endif
	jll:=Random(jkl)
	If Jll=1 Then
		T2T:=Robank3
		Plyr(PMoney):=IncStr(Plyr(PMoney),Str2Int(t2t))
		WriteLn('|CR|14You successfully hacked out cards!')
		WriteLn('|06You transferred |14$' + T2T + '|06 to your account!')
	Else
		WriteLn('|CR|14You were caught.  |06The LLL now requires you to crash more harddrives to make')
		WriteLn('another level.')
		Plyr(PDl):=IncStr(Plyr(PDl),Str2Int(Plyr(PLev))*5)
	Endif
	SavePlyr(PlyrIdx)
	Paws
Pend

Procedure Robank
Begin
	WriteLn('|CR|11Failing to hack out the credit cards will get the LLL *MAD*.')
	If Times>=3 Then
		WriteLn('|CR|12Sorry, you can only try to hack the')
		WriteLn('cards 3 times.|11')
	Else
		If InputYN('|CR|10Still hack? ') Then
			Times:=Times+1
			Robank2
		Else
			WriteLn('|CR|12Aborted.')
		Endif
	Endif
Pend

Function MakeRank(UIdx Integer) : String
Var I7	Integer
Var I8	Integer
Var I9	Integer
Begin
	I7:=29
	I8:=0
	I9:=0
	For I5:=1 to 30
		For I6:=1 to PlyrCnt
			If ReadSane(I6) = 1 Then
				If Str2Int(Sane(PLev))=I5+I7 Then
					I8:=I8+1
					If Str2Int(Sane(PIdx)) = UIdx Then
						MakeRank:=Int2Str(I9)
					Endif
				Endif
			Endif
		Fend
		I9:=I8+1
		I7:=I7-2
	Fend
Pend

Procedure CountPlyrs
Begin
	PlyrCnt:=1
	While ReadSane(PlyrCnt) = 1 
		PlyrCnt:=PlyrCnt+1
	Wend
	PlyrCnt:=PlyrCnt-1
Pend

Procedure HSpell
Begin
Pend

Procedure Fight2
Var hta		LongInt
Var htb		LongInt
Var htc		LongInt
Var hthm	LongInt
Var htyu	LongInt
Var PA		Integer
Var OA		Integer
Var PW		Integer
Var OW		Integer
Var PH		Integer
Var OH		Integer
Begin
	hta:=random(10)
	htb:=random(10)
	htc:=random(10)
	PW:=Str2Int(Plyr(PWeapNo))
	PA:=Str2Int(Plyr(PArmNo))
	OW:=Str2Int(Othr(PWeapNo))
	OA:=Str2Int(Othr(PArmNo))
	PH:=Str2Int(Plyr(PMegs))
	OH:=Str2Int(Othr(PMegs))
	hthm:=PW*Hta
	hthm:=hthm/OA
	htyu:=OW*htb
	htyu:=htyu/PA
	If hthm>=1 Then
		WriteLn('|CRYou trash ' + Int2Str(hthm) + ' megs!')
	else
		WriteLn('|CRYou got line noise!')
	Endif
	OH:=OH-hthm
	Othr(PMegs):=Int2Str(OH)

	If htyu>=1 Then
		WriteLn('They purge ' + Int2Str(htyu) + ' megs!')
	Else
		WriteLn('They deleted an EMPTY directory!')
	Endif
	PH:=PH-htyu
	If HtC=6 Then
			HSpell
		Endif
	Endif
	Plyr(PMegs):=Int2Str(PH)
Pend

Procedure UpDa2
Var L1	Integer
Var L2	Integer
Var G1	Integer
Var G2	Integer
Var Ttxt	String
Begin
	Othr(PMoney):='0'
	L1:=Str2Int(Plyr(PLev))
	L2:=Str2Int(Othr(PLev))
	G1:=Str2Int(Plyr(PDl))
	G2:=Str2Int(Othr(PDl))
	If L1 >= L2 Then
		I5:=L2*3
		G1:=G1-I5
		If G1>0 Then
	WriteLn('|CR|10The LLL is proud and will give you credit for this.')
		Endif
		If G1<=0 Then
	WriteLn('|CR|10The LLL couldn''t be more proud!  They promote you a level!')
		Endif
		Plyr(Pdl):=Int2Str(G1)
		SavePlyr(PlyrIdx)
	Endif
	If L1<L2 Then
		Ttxt:=Plyr(PLev)
		Plyr(PLev):=Othr(PLev)
		Othr(PLev):=Ttxt
		I5:=G1
		I2:=L1	
		G1:=G2
		L1:=L2
		G2:=I5
		L2:=I2
		Plyr(PDl):=Int2Str(G1)	
		Plyr(PLev):=Int2Str(L1)
		WriteLn('|CR|10The LLL promotes you to level |11' + Plyr(PLev) + '|10!')
		WriteLn('|11They demote him to level |10' + Othr(PLev) + '|11!')
		SavePlyr(PlyrIdx)
		SaveOthr(OthrIdx)
	Endif
	If Str2Int(Plyr(PWeapNo)) <= Str2Int(Othr(PWeapNo)) Then
		WriteLn('|CR|10You downloaded his software!')
		Ttxt:=Plyr(PWeap)
		Plyr(PWeap):=Othr(PWeap)
		Othr(PWeap):=Ttxt
		Ttxt:=Plyr(PWeapNo)
		Plyr(PWeapNo):=Othr(PWeapNo)
		Othr(PWeapNo):=Ttxt
		SavePlyr(PlyrIdx)
		SaveOthr(OthrIdx)
	Endif
	If Str2Int(Plyr(PArmNo)) <= Str2Int(Othr(PArmNo)) Then
		WriteLn('|CR|10You stole his backup!')
		Ttxt:=Plyr(PArm)
		Plyr(Parm):=Othr(PArm)
		Othr(PArm):=Ttxt
		Ttxt:=Plyr(PArmNo)
		Plyr(PArmNo):=Othr(PArmNo)
		Othr(PArmNo):=Ttxt
		SavePlyr(PlyrIdx)
		SaveOthr(OthrIdx)
	Endif
Pend

Procedure UpDa
Var L1	LongInt
Var V1	Integer	
Var V2	Integer	
Var G1	Integer
Var Ttxt	String
Begin
	L1:=Str2Int(Othr(PMoney)) + Str2Int(Plyr(PMoney))
	Plyr(PMoney):='0'
	V1:=Str2Int(Plyr(PLev))
	V1:=V1*3
	G1:=Str2Int(Othr(PDl))
	G1:=G1-V1
	If G1 <= 0 Then
		V2:=Str2Int(Othr(PLev))
		V2:=V2+1
		Othr(PLev):=Int2Str(V2)
		G1:=V2*10
		Othr(PDl):=Int2Str(G1)
		SaveOthr(OthrIdx)
		SavePlyr(PlyrIdx)
	Endif
	G1:=Str2Int(Othr(PWeapNo))
	V1:=Str2Int(Plyr(PWeapNo))
	If G1<V1 Then
		WriteLn('|CRHe downloaded your software!')
		ttxt:=Str2Int(Othr(PWeapNo))
		Othr(PWeapNo):=Plyr(PWeapNo)
		Plyr(PWeapNo):=ttxt
		SaveOthr(OthrIdx)
		SavePlyr(PlyrIdx)
	Endif
	G1:=Str2Int(Othr(PArmNo))
	V1:=Str2Int(Plyr(ParmNo))
	If G1<V1 Then
		WriteLn('|CRHe stole your backup!')
		ttxt:=Str2Int(Othr(PArmNo))
		Othr(PArmNo):=Plyr(PArmNo)
		Plyr(PArmNo):=ttxt
		SaveOthr(OthrIdx)
		SavePlyr(PlyrIdx)
	Endif
Pend

Procedure YouDead
Var L1	LongInt
Var L2	Integer	
Begin
	L1:=Str2Int(Plyr(PMoney))
	L1:=L1/2
	WriteLn('|CRThere goes your hard disk!')
	If Guf = 0 Then Upda 						Endif
	If Guf = 1 Then Plyr(PMoney):=Int2Str(L1) 	Endif
	L2:=Str2Int(Plyr(PLev))
	If L2 > 30 Then
		Plyr(PLev):='30'
		Plyr(PDl):='300'
	Endif
	Plyr(PMegs):='0'
	SavePlyr(PlyrIdx)
Pend

Procedure MLev
Var L1	Integer
Begin
	L1:=Str2Int(Plyr(PLev))
	L1:=L1+1
	Plyr(PLev):=Int2Str(L1)
	Plyr(PDl):=Int2Str(L1*10)
	WriteLn('|CR|10The LLL is please with this performance.  You are now level |11'+ Plyr(PLev) + '|10!')
	Plyr(PHP):=Plyr(Pdl)
	Plyr(PMegs):=Plyr(PHP)

	L1:=Str2Int(Plyr(PTroj))
	L1:=L1+1
	If L1 < 0 Then L1:=0 Endif
	If L1 > 30 Then L1:=30 Endif
	Plyr(PTroj):=Int2Str(L1)
	L1:=Str2Int(Plyr(PFBu))
	L1:=L1+1
	If L1 < 0 Then L1:=0 Endif
	If L1 > 30 Then L1:=30 Endif
	Plyr(PFBu):=Int2Str(L1)
	SavePlyr(PlyrIdx)
Pend

Procedure TheyDead
Begin
	WriteLn('|CRTheir computer is FRIED!')
	WriteLn('|CRAnd look!  Here''s his credit card # with $' + Othr(PMoney) + ' in the account!')
	Plyr(PMoney):=IncStr(Plyr(PMoney),Str2Int(Othr(PMoney)))
	If Guf = 0 Then
		UpDa2
	Endif
	If Guf = 1 Then	
		Plyr(PDl):=DecStr(Plyr(Pdl),Num)
	Endif
	If Str2Int(Plyr(PDl)) <= 0 Then	MLev Endif
	SavePlyr(PlyrIdx)
Pend

Procedure Trojan
Var JI	Integer
Begin
	If Str2Int(Plyr(PTroj)) <=0 Then
		WriteLn('|CROOOPS!  You accidentally erased it!')
	Else
		Plyr(PTroj):=DecStr(Plyr(PTroj),1)
		JI:=Random(5)*Str2Int(Plyr(PWeapNo))
		WriteLn('|You upload a trojan horse|DE.|DE.|DE.')
		WriteLn('|CRThe idiot runs it!  '+Int2Str(JI) + ' megs are trashed!')
		Othr(PMegs):=DecStr(Othr(PMegs),JI)
	Endif
Pend

Procedure RestoreFiles
Var Ji	Integer
Begin
	If Str2Int(Plyr(PFBu)) < 1 Then 
		WriteLn('|CRThe files were completely purged!')
		Plyr(PFBu):='0'
	Else
		Plyr(PFBu):=DecStr(Plyr(PFBu),1)
		Ji:=Random(5)*Str2Int(Plyr(PArmNo))
		WriteLn('|CRYou run a backup packup program|DE.|DE.|DE.')
		If Str2Int(Plyr(PMegs))+JI > Str2Int(Plyr(Php)) Then
			WriteLn('|CRYou recover all of your megs back!')
		Else
			WriteLn('|CRYou recover ' + Int2Str(Ji) + ' megs back!')
		Endif
		Plyr(PMegs):=IncStr(Plyr(PMegs),JI)
		If Str2Int(Plyr(PMegs)) > Str2Int(Plyr(Php)) Then
			Plyr(PMegs):=Plyr(Php)
		Endif
	Endif
	SavePlyr(PlyrIdx)	
Pend

Procedure Fight
Var Done1	Boolean
Var C1		Char
Begin
	Done1:=false
	Run:=0
	WriteLn('|CRYou begin to hack!|CR')
	While not done1
		WriteLn('|CR|10You have |15' + Plyr(PMegs) + '|10 megs left.')
		WriteLn('|10They have |15' + Othr(PMegs) + '|10 megs left.')
		Write  ('|CR|10[T]rash Files, [D]rop Carrier, [U]pload Trojan Horse, or [B]ackup Files: |11')
		C1:=OneKey('TDUB')
		If 		C1 = 'T' 	then	Fight2
		ElseIf	C1 = 'D'	Then	Run:=1
		ElseIf	C1 = 'U'	Then	Trojan
		ElseIf	C1 = 'B'	Then	RestoreFiles
		Endif
		I5:=Str2Int(Plyr(PMegs))
		I4:=Str2Int(Othr(PMegs))
		If I5 <=0 or I4 <=0 or C1 = 'D' Then
			Done1:=True
		Endif
	Wend
	If Str2Int(Plyr(PMegs)) <=0	Then	
		YouDead		
	ElseIf Str2Int(Othr(PMegs)) <=0	Then	
		TheyDead	
	ElseIf	Run=1 Then
		WriteLn('|CRNO CARRIER|CR')
	Endif
Pend

Procedure FBat
Begin
	cls
	WriteLn('|CRCongratulations, ' + Plyr(PName) +'!')
	WriteLn('You have become a level 31 leech!  Now time for the BIG challenge.')
	WriteLn('You have to crash the LLL computer!  Yes, you have all of your megs back,')
	WriteLn('but you''ll need them against the LLL.  If you fail, the LLL will be mad.')
	WriteLn('and demote you to level 30.  Good luck!')
	Paws
	Othr(PHp):='360'
	Plyr(PHp):='310'
	Othr(PWeapNo):=Plyr(PWeapNo)
	Othr(PArmNo):=Plyr(PArmNo)
	Fight
	If Run=1 Then
		WriteLn('|CRThe LLL is pissed.  Go back and repeat level 30!')
		Plyr(PLev):='30'
		Plyr(PDl):='300'
		SavePlyr(PlyrIdx)
	Else
		WriteLn('|CRThe LLL''s computer is done for!  They enter you into the leech hall of fame!')
		If fExist(CfgTextPath+'hallfame.lch')
			fopen(4,Text,Append,CfgTextPath+'hallfame.lch')	
		Else
			fopen(4,Text,Rewrite,CfgTextPath+'hallfame.lch')	
		Endif
		fWriteLn(4,Plyr(PName))
		fClose(4)
		If fexist(F1) then
			ferase(F1)
			WriteLn('|CRThe Game has been rerolled!')
			WriteLn('|CRNow returning to an environment with even WORSE users...')
			paws
			halt
		Endif
	Endif
Pend

Procedure MakeScores 
Var J1	Integer
Var TTXT1	String
Begin
	GetCfg
	fOpen(4,text,Rewrite,CfgTextPath+SF)
	fWriteLn(4,'|CL|06.:|14[ |11'+ProgName+' '+ProgVer+'|06, a Mysti BBS mpl, |06'+ProgAuth+'|CR')
	fWriteLn(4,'|11Player List|CR')
	fWriteLn(4,'|10## Rank Lev LastOn     Name')
	fWriteLn(4,'-- ==== --- ========   ------------------------------------|11')
	Num:=1
	J1:=1
	For Num:=1 to PlyrCnt
		If ReadOthr(Num) = 1
			If Odd(J1) Then TTxt1:='|15' Else TTxt1:='|07' endif
			Othr(PRank):=MakeRank(Num)
			TTxt1:=TTxt1+PadLt(Othr(PIdx),2,' ') + ' '
			TTxt1:=TTxt1+PadLt(Othr(PRank),4,' ') + ' '
			TTxt1:=TTxt1+PadLt(Othr(PLev),3,' ') + ' '
			TTxt1:=TTxt1+PadRt(Othr(PLastOn),10,' ') + ' '
			If Odd(J1) Then TTxt1:=TTxt1+'|06' Else TTxt1:=TTxt1+'|14' Endif
			TTxt1:=TTXt1+Othr(PName)
			fWriteLn(4,TTxt1)
			J1:=J1+1
		Endif
	Fend
	fWriteLn(4,'|CR|PA')
	fClose(4)
Pend

Procedure ListPlyrs
Begin
	MakeScores
	DispFile(SF)
Pend

Procedure Examine 
Var Done1	Boolean
Var UStr	String
Var TStr	String
Var Cstu	Integer
Begin
	Cstu:=Str2Int(Plyr(PLev)) * 10
	Write('|CRName (Or Partial) of Leech to Examine: ')
	UStr:=Input(30,30,12,'')
	If UStr = '?' Then
		ListPlyrs
	Else
		I5:=1
		While ReadOthr(I5) = 1
			TStr:=Upper(Othr(PName))
			If Pos(UStr,TStr) > 0  and Othr(PName) <> Plyr(PName) Then
				If InputYN('|CR|11Do you mean |14' + Othr(PName) + '|11? ') Then
					If InputYN('|CRAre you aware that it will cost you $' + Int2Str(cstu) + '? ') Then
						If Str2Int(Plyr(PMoney)) >= Cstu Then
							Plyr(PMoney):=Int2Str(Str2Int(Plyr(PMoney))-Cstu)
							SavePlyr(PlyrIdx)
							WriteLn('|CRLeech  :   #' + Othr(PIdx) + ' ' + Othr(PName))
							WriteLn('Level     :    ' + Othr(PLev))
							WriteLn('Rank      :    ' + Othr(PRank))
							WriteLn('Software  :    ' + Othr(PWeap))
							WriteLn('Backup    :    ' + Othr(PArm))
							WriteLn('Money     :    ' + Othr(PMoney))
							WriteLn('Megs Left :    ' + Int2Str(Str2Int(Othr(PLev))*10) + '(' + Int2Str(Str2Int(Othr(PLev))*10) + ')')
						Else
							WriteLn('|CRYou can''t afford to do that!')
							Paws	
						Endif
					Else
						WriteLn('|CRThe why did you do this command?')
					Endif
				Endif
			Endif
			I5:=I5+1
		Wend
	Endif
	Paws
Pend

Procedure Call
Var Ttxt1	String
Begin
	If Str2Int(Plyr(PCalls)) > 0 then
		Plyr(PCalls):=DecStr(Plyr(PCalls),1)
	Else
		WriteLn('|CROveruse error.')
		exit
	Endif
	WriteLn('|CLWelcome to ' + Plyr(PWeap) + '!')
	Num:=0
	Repeat
		Write('Which BBS to call? (? for list) ')
		Ttxt1:=Input(3,3,12,'')
		If Ttxt1 = '?' Then
			DispFile('bbs.lch')	
		Endif
		Num:=Str2Int(Ttxt1)
	Until Num > 0 and Num < 100
	If Num>=1 Then
		WriteLn('Dialing|DE.|DE.|DE.|CR')
		WriteLn('CONNECT')
		Plyr(PFights):=DecStr(Plyr(PFights),1)
		Othr(PMegs):=Int2Str(Num*7)
		Othr(PMoney):=Int2Str(Num*60)
		Othr(PWeapNo):=Int2Str(Num)
		Othr(PArmNo):='1'
		Guf:=1
		Fight
	Else
		WriteLn('|CRAborted.')
	Endif	
Pend

Procedure HealW
Begin
	I6:=Str2Int(Plyr(PLev))*4
	If Str2Int(Plyr(PMoney))>=I6*Num Then
		Plyr(PMoney):=DecStr(Plyr(PMoney),I6*Num)
		Plyr(PMegs):=IncStr(Plyr(PMegs),Num)
		WriteLn('|CRYou recover ' + Int2Str(Num) + ' megs!')
	Else
		WriteLn('|CRGet Out!  You don''t have enough money!')
	Endif
Pend

Procedure Doctor
Begin
	I5:=Str2Int(Plyr(PhP))-Str2Int(Plyr(PMegs))
	I6:=Str2Int(Plyr(PLev))*4
	WriteLn('|CLYou have ' + Int2Str(I5) + ' deleted megs.')
	WriteLn('It will cost $'+ Int2Str(I6) + ' to recover each meg.')
	Write  ('|CRUnerase [A]ll or [S]ome megs? ')
	If OneKey('AS') = 'A' Then
		Num:=I5
		HealW
	Else
		Repeat
			Write('|CRHow many megs to unerase? ')
			Num:=Str2Int(Input(3,3,12,''))
		Until Num >= 0 or Num<=I5
		If Num > 0 Then
			HealW
		Else
			WriteLn('|CRAborted.')
		Endif
	Endif
	SavePlyr(PlyrIdx)
Pend

Procedure Hack
Var Done1	Boolean
Var UStr	String
Var TStr	String
Var M1		Integer
Begin
	If Str2Int(Plyr(PFights)) > 0 then
		Plyr(PFights):=DecStr(Plyr(PFights),1)
	Else
		WriteLn('|CROveruse error.')
		Exit
	Endif
	Guf:=0
	If Str2Int(Plyr(PFights)) > 0 Then
		Write('|CRName (Or Partial) of Leech to Hack : ')
		UStr:=Input(30,30,12,'')
		If UStr = '?' Then
			ListPlyrs
		Else
			I5:=1
			While ReadOthr(I5) = 1
				TStr:=Upper(Othr(PName))
				If Pos(UStr,TStr) > 0  and Othr(PName) <> Plyr(PName) Then
				If InputYN('|CR|11Do you mean |14' + Othr(PName) + '|11? ') Then
						OthrIdx:=Str2Int(Othr(PIdx))
						Othr(PMegs):=Othr(PHP)
						SaveOthr(OthrIdx)
						Fight
					Endif
				Endif
				I5:=I5+1
			Wend
		Endif
	Else
		WriteLn('|CRYou have used up all your fights for today.')
	Endif
Pend


Function FindPlyr(Strg String):Integer
Var RetNo	Integer	
Begin
	RetNo:= 1
	RetNo:=RetNo-2
	For I5:=1 to PlyrCnt
		If ReadSane(I5) = 1
			If Sane(PName) = Strg then
				RetNo:=I5
			Endif
		Endif
	Fend
	FindPlyr:=RetNo
Pend

Procedure InitGame
Begin
	Times:=0
	Today:=DateStr(DateTime,1)
	I5:=1
	I5:=I5-2
	CountPlyrs
	If PlyrCnt > 0 Then
		I5:=FindPlyr(UserAlias) 
	Endif
	If I5 < 0 Then
		WriteLn('|CR|11Hello, new leech!')	
		PlyrCnt:=PlyrCnt+1
		InitPlyr(PlyrCnt)
		SavePlyr(PlyrIdx)
	Else
		If ReadPlyr(I5) = 1 then
			PlyrIdx:=Str2Int(Plyr(PIdx))
			WriteLn('|CR|11Welcome Back, ' + Plyr(PName))
			If Plyr(PLaston) <> today then
				Plyr(PRuns):='3'
				Plyr(PTroj):=Plyr(PLev)
				Plyr(PFBu):=Plyr(PLev)
			Else
				Plyr(PRuns):=DecStr(Plyr(PRuns),1)
			Endif
			Plyr(PFights):=Int2Str(Str2Int(Plyr(PLev))+10)
			Plyr(PCalls):=Int2Str(Str2Int(Plyr(PLev))+3)
			Plyr(PMegs):=Plyr(PHP)
			Plyr(PLastOn):=DateStr(DateTime,1)
			SavePlyr(PlyrIdx)
		Else
			WriteLn('Error reading player record.')
		Endif
	Endif
	MenuCmd('NA','Mysitc Leech')
Pend

Procedure Cruns
Begin
	I5:=Str2Int(Plyr(PRuns))
	If I5 < 1 Then 
		WriteLn('|11Hey, you ARE a leech!  Only 3 times per day!|11')
		Paws
		If ACS('s255')
			WriteLn('|CRBut since you are GOD, you can play.|11')
		Else
			Halt
		Endif
	Else
		If I5 > 0 Then
			Plyr(PRuns):=DecStr(Plyr(PRuns),1)
			Plyr(PMegs):=Plyr(PHP)
			SavePlyr(PlyrIdx)
		Endif
		WriteLn('|CL|11Glad to see you back, '+ Plyr(PName) + '!')
		Paws
	Endif
Pend

Procedure Status
Begin
	Cls
	Plyr(PRank):=MakeRank(PlyrIdx)
	WriteLn('|10Leech                   |11#' + Plyr(PIdx) + ' ' + Plyr(PName))
	WriteLn('|10Level                   |11' + Plyr(PLev))
	WriteLn('|10Rank                    |11' + Plyr(PRank))
	WriteLn('|10Software                |11' + Plyr(PWeap))
	WriteLn('|10Backup                  |11' + Plyr(PArm))
	WriteLn('|10Drives Left to Crash    |11' + Plyr(PDl))
	WriteLn('|10Money                  $|11' + Plyr(PMoney))
	WriteLn('|10Money in LLL Account   $|11' + Plyr(PBank))
	WriteLn('|10Games Left Today        |11' + Plyr(PRuns))
	WriteLn('|10Fast Backups Left       |11' + Plyr(PFBu))
	WriteLn('|10Trojan Horses Left      |11' + Plyr(PTroj))
	WriteLn('|10Calls to BBSes Left     |11' + Plyr(PCalls))
	WriteLn('|10Calls to Leeches  Left  |11' + Plyr(PFights))
	WriteLn('|10Megs Left               |11' + Plyr(PMegs) + ' |10(|11' + Plyr(PHP)+ '|10)')
Pend


Procedure AddBank
Begin
	Plyr(PBank):=IncStr(Plyr(PBank),Str2Int(Plyr(PMoney)))
	Plyr(PMoney):='0'
	SavePlyr(PlyrIdx)
	WriteLn('|CR|11$' + Plyr(PBank) + ' now in LLL Account..')
Pend

Procedure SubBank
Begin
	Plyr(PMoney):=IncStr(Plyr(PMoney),Str2Int(Plyr(PBank)))
	Plyr(PBank):='0'
	SavePlyr(PlyrIdx)
	WriteLn('|CR|11$' + Plyr(PMoney) + ' now in possesion.  $0 in LLL Account.')
Pend

Procedure ListArmor
Var A1	Integer
Var B1	LongInt	
Begin
	A1:=1
	B1:=0
	WriteLn('|10Num: Strength  Price     Armor') 
	WriteLn('|10---- --------  --------- ------------------|11')
	While ReadItem(A1) = 1 and A1 <= 15
		If Str2Int(Plyr(PMoney)) >= B1 Then
			Write  (PadLt(Int2Str(GNum),3,' ') + ': ' )
			Write  (PadRt(Int2Str(GStr),8,' ') + ' $' )
			WriteLn(PadLt(Int2Str(GPrice),9,' ') + ' ' + GArm)
			B1:=GPrice
		Endif
		A1:=A1+1
	Wend
	WriteLn('|10---- --------  --------- ------------------')
	WriteLn('|11You have $'+Plyr(PMoney))
Pend

Procedure SellArmor
Begin
	If ReadItem(Str2Int(Plyr(PArmNo))) = 1 Then
		WriteLn('|CR|11You can sell your |10' + GArm + '|11 for |10$' + Int2Str(GPrice/2) + '|11.')
		If InputYN('Do you wish to do so? ') Then
			WriteLn('|CR|10Backup Sold!')
			Plyr(PArm):='None'
			Plyr(PArmNo):='1'
			Plyr(PMoney):=IncStr(Plyr(PMoney),GPrice/2)
			SavePlyr(PlyrIdx)
		Else
			WriteLn('|CR|12Aborted.')
		Endif
	Else
		WriteLn('|CR|12Error reading Armor Record')
	Endif
Pend

Procedure BuyArmor
Var Done1	boolean
Var Ttxt	String
Var L1		LongInt
Begin
	L1:=Str2Int(Plyr(PMoney))
	ListArmor
	Done1:=False
	While not done1
		Write('|CR|11Enter number of backup you wish to buy: ')
		Num:=Str2Int(input(2,2,12,''))
		If Num >= 1 And Num <=15 Then
			If ReadItem(Num)=1 Then
				WriteLn('|CR|11A |10' + GArm + '|11 costs |10$' + Int2Str(GPrice) + '|11.')
				If InputYN('|11Do you wish to purchase it? ') Then
					If L1 < GPrice Then
						WriteLn('|CR|12That price is over your savings!')
					Else
						WriteLn('|CR|10Backup bought.')
						Plyr(PArm):=GArm
						Plyr(PArmNo):=Int2Str(GNum)
						Plyr(PMoney):=DecStr(Plyr(PMoney),GPrice)
						SavePlyr(PlyrIdx)
						Done1:=True
					Endif 
				Else
					WriteLn('|CR|10Aborted.')
				Endif
			Else
				WriteLn('|CR|12Invalid Amount!  Try again!')
			Endif
		Else
			Done1:=True
		Endif
	Wend
Pend

Procedure ShopArmor
Var Ch1	Char
Begin
	Ch1:=''	
	While Ch1 <> 'Q'
		Cls
		WriteLn('|11LLL Backup Shop|CR')
		WriteLn('|11Options: ')
		WriteLn(' |11[|10B|11] Buy Backup')
		WriteLn(' |11[|10S|11] Sell Backup')
		WriteLn(' |11[|10L|11] List Backup')
		WriteLn(' |11[|10Q|11] Quit')
		Write('|CR|11Which (|10B,L,S,Q,?|11) : ')
		Ch1:=OneKey('BSLQ')
		If		Ch1 = 'B'	Then	BuyArmor	Paws
		ElseIf	Ch1 = 'L'	Then	ListArmor	Paws
		ElseIf	Ch1 = 'S'	Then	SellArmor
		Endif
	Wend
Pend

Procedure ListWeapon
Var A1	Integer
Var B1	LongInt
Begin
	A1:=1
	B1:=0
	WriteLn('|11Num: Strength  Price     Weapon') 
	WriteLn('|11---- --------  --------- ------------------|10')
	While ReadItem(A1) = 1 and A1 <= 15
		If Str2Int(Plyr(PMoney)) >= B1 Then
			Write  (PadLt(Int2Str(GNum),3,' ') + ': ' )
			Write  (PadRt(Int2Str(GStr),8,' ') + ' $' )
			WriteLn(PadLt(Int2Str(GPrice),9,' ') + ' ' + GWep)
			B1:=GPrice
		Endif
		A1:=A1+1
	Wend
	WriteLn('|11---- --------  --------- ------------------')
	WriteLn('|10You have $'+Plyr(PMoney))
Pend

Procedure SellWeapon
Begin
	If ReadItem(Str2Int(Plyr(PWeapNo))) = 1 Then
		WriteLn('|CR|11You can sell your |10' + GWep + '|11 for |10$' + Int2Str(GPrice/2) + '|11.')
		If InputYN('|11Do you wish to do so? ') Then
			WriteLn('|CR|10Software Sold!')
			Plyr(PWeap):='None'
			Plyr(PWeapNo):='1'
			Plyr(PMoney):=IncStr(Plyr(PMoney),GPrice/2)
			SavePlyr(PlyrIdx)
		Else
			WriteLn('|CR|12Aborted.')
		Endif
	Else
		WriteLn('|CR|12Error reading Software Record')
	Endif
Pend


Procedure BuyWeapon
Var Done1	boolean
Var Ttxt	String
Var L1		LongInt
Begin
	L1:=Str2Int(Plyr(PMoney))
	ListWeapon
	Done1:=False
	While not done1
		Write('|CR|10Enter number of Software you wish to buy: |11')
		Num:=Str2Int(input(2,2,12,''))
		If Num >= 1 And Num <=15 Then
			If ReadItem(Num)=1 Then
				WriteLn('|CR|11A |10' + GWep + '|11 costs |10$' + Int2Str(GPrice) + '|11.')
				If InputYN('|11Do you wish to purchase it? ') Then
					If L1 < GPrice Then
						WriteLn('|CR|12That price is over your savings!')
					Else
						WriteLn('|CR|10Software bought.')
						Plyr(PWeap):=GWep
						Plyr(PWeapNo):=Int2Str(GNum)
#						Plyr(PMoney):=Int2Str(L1-GPrice)
						Plyr(PMoney):=DecStr(Plyr(PMoney),GPrice)
						SavePlyr(PlyrIdx)
						Done1:=True
					Endif 
				Else
					WriteLn('|CR|12Aborted.')
				Endif
			Else
				WriteLn('|CR|12Invalid Amount!  Try again!')
			Endif
		Else
			Done1:=True
		Endif
	Wend
Pend

Procedure ShopWeapon
Var Ch1	Char
Begin
	Ch1:=''	
	While Ch1 <> 'Q'
		Cls
		WriteLn('|10LLL Software Shop|CR')
		WriteLn('|10Options: ')
		WriteLn(' |11[|10B|11] Buy Software')
		WriteLn(' |11[|10S|11] Sell Software')
		WriteLn(' |11[|10L|11] List Software')
		WriteLn(' |11[|10Q|11] Quit')
		Write('|CR|11Which (|10B,L,S,Q,?|11) : ')
		Ch1:=OneKey('BSLQ')
		If		Ch1 = 'B'	Then	BuyWeapon
		ElseIf	Ch1 = 'L'	Then	ListWeapon Paws
		ElseIf	Ch1 = 'S'	Then	SellWeapon
		Endif
	Wend
Pend

Procedure LLL
Var Ch1	Char
Begin
	If Str2Int(Plyr(PLev))>30	Then Fbat	Endif
	Cls
	WriteLn('|CR|11Dialing LLL|DE.|DE.|DE.|DECONNECT|CR')
	Ch1:=''
	While Ch1 <> 'Q'
		DispFile('lllmenu.lch')
		WriteLn('|10Welcome to the Lame Local Leeches BBS!')
		Write('|CR|11Command (? for Help): ')
		Ch1:=Onekey('DQHCLEGBS?')
		If      Ch1 = 'Q' 	Then	WriteLn('|CRNO CARRIER')
		ElseIf	Ch1 = 'D'	Then	DispFile('hallfame.lch')	Write('|CR|PA')
		ElseIf	Ch1 = 'L'	Then	ListPlyrs
		ElseIf	Ch1 = 'H'	Then	ShopArmor	
		ElseIf	Ch1 = 'S'	Then	ShopWeapon
		ElseIf	Ch1 = 'E'	Then	Examine	
		ElseIf	Ch1 = 'B'	Then	LLLBull
		ElseIf	Ch1 = 'C'	Then	Robank	
		Endif
	Wend
Pend

Procedure Format
Begin
	If InputYN('|CRFormat Harddrive -- will erase all stats.  Sure? ') Then
		InitPlyr(PlyrIdx)
		WriteLn('|CRHarddrive formatted.')
	Else
		WriteLn('|CRAborted.')
	Endif
Pend

Begin
	cls
	DispFile('opening.lch') paws
	InitGame
	Cruns
	ReadBull
	Done:=False
	DispFile('ibmmenu.lch')
	While Not Done
		WriteLn('|CR|10(?=Help)')
		Write('|11C:\> ')
		iStr:=Input(10,10,12,'')
		If      iStr = 'QUIT'	Then Done:=True 
		ElseIf	iStr = 'FORMAT'	Then Format 
		ElseIf	iStr = 'STATUS'	Then Status	
		ElseIf	iStr = 'LIST'	Then ListPlyrs
		ElseIf	iStr = 'HACK'	Then Hack 
		ElseIf	iStr = 'CALL'	Then Call 
		ElseIf	iStr = 'LLL'	Then LLL 
		ElseIf	iStr = 'UE'		Then Doctor
		ElseIf	iStr = '+'		Then AddBank 
		ElseIf	iStr = '-'		Then SubBank 
		ElseIf	iStr = '?'		Then DispFile('ibmmenu.lch')
		Endif		
	Wend
	MakeScores
End
