// ---(Description)-----------------------------------------------------------
// Mystic Leech v1.0 By Darryl Perry, 2003.  A Cyberia BBS Production
//
// Mystic Leech is a Mystic MPL version of the classic, original BBS online
// game of Leech.
//
// Although this program is entered into the public domain, please give
// credit where credit is due.  If you use this program, or portions thereof,
// plese give due credit.
//
// More informaton can be found in the sysop.txt file of the gy-lch10.zip
// ---------------------------------------------------------------------------

Uses Cfg,
User;

Const	ProgName	=	'Mystic Leech'
Const	ProgVer		=	'v2.0'
Const	ProgAuth	=	'Darryl Perry, 2012'
Const	PlyrFileName	=	'leech.ply'
Const	ItemFileName	=	'leech.itm'
Const 	P		=	0
Const 	O		=	1
Const 	S		=	2


Type
	PlyrRec = Record
		Idx		:	Integer
		Name		:	String[30];
		Alias		:	String[30];
		LastOn		:	LongInt;
		Weap		:	String[20];	
		WeapNo		:	Integer;
		Arm		:	String[20];	
		ArmNo		:	Integer	
		Lev		:	Integer;	
		HP		:	Integer;	
		Runs		:	Integer;
		Money		:	LongInt;	
		Bank		:	LongInt;	
		Dl		:	Integer;	
		Rank		:	Integer;	
		Calls		:	Integer;	
		Fights		:	Integer;
		Megs		:	Integer;	
		FBu		:	Integer;	
		Troj		:	Integer;	
	End

Var Plyr		:PlyrRec
Var Othr		:PlyrRec
Var Sane		:PlyrRec
Var PlyrFile		:String
Var ItemFile		:String
Var F3			:String
Var Done		:Boolean	
Var PlyrCnt		:Integer
Var GNum		:Integer
Var IStr		:String
Var GStr		:Integer
Var GPrice		:LongInt	
Var GWep		:String
Var GArm		:String
Var Today		:String
Var BulletFile		:String
Var ScoresFile		:String
Var Guf			:Integer	
Var I1			:Integer
Var I2			:Integer
Var I3			:Integer
Var I4			:Integer
Var I6			:Integer
Var Num			:Integer
Var Times		:Integer
Var Run			:Integer
Var Params		:String
Var F4			:File
Var PlyrFilePtr		:File
Var ItemFilePtr		:File
Var TF  		:Boolean
Var CX			:Char
Var Done1		:Boolean
Var Ch1			:Char
Var Ch2			:Char
Var Px1 		:String


Procedure Paws
Begin
	Write('|CR|PA')
End

Procedure ReadSane(PIdx: Integer) : Integer
Var Ret    : Integer
Begin

	If Not FileExist(PlyrFile) Then
		Ret:=0
	Else Begin
		fAssign(PlyrFilePtr,PlyrFile,66)
		fReset(PlyrFilePtr)
		fSeek(PlyrFilePtr,SizeOf(Sane)*(PIdx-1))
		If IoResult <> 0 Or fEof(PlyrFilePtr) Then
			Ret:=0
		Else Begin
			fRead(PlyrFilePtr,Sane.Idx,2)
			fRead(PlyrFilePtr,Sane.Name,31)
			fRead(PlyrFilePtr,Sane.Alias,31)
			fRead(PlyrFilePtr,Sane.LastOn,4)
			fRead(PlyrFilePtr,Sane.Weap,21)
			fRead(PlyrFilePtr,Sane.WeapNo,2)
			fRead(PlyrFilePtr,Sane.Arm,21)
			fRead(PlyrFilePtr,Sane.ArmNo,2)
			fRead(PlyrFilePtr,Sane.Lev,2)
			fRead(PlyrFilePtr,Sane.HP,2)
			fRead(PlyrFilePtr,Sane.Runs,2)
			fRead(PlyrFilePtr,Sane.Money,4)
			fRead(PlyrFilePtr,Sane.Bank,4)
			fRead(PlyrFilePtr,Sane.Dl,2)
			fRead(PlyrFilePtr,Sane.Rank,2)
			fRead(PlyrFilePtr,Sane.Calls,2)
			fRead(PlyrFilePtr,Sane.Fights,2)
			fRead(PlyrFilePtr,Sane.Megs,2)
			fRead(PlyrFilePtr,Sane.FBu,2)
			fRead(PlyrFilePtr,Sane.Troj,2)
			Ret:=1
		End
	End

	fClose(PlyrFilePtr)
	ReadSane:=Ret
End

Procedure SavePlyr(PIdx, OP1 : Integer) : Integer
Var Ret	   : Integer
Var TmpFile: String
VAr FileHere: Boolean
Begin
	FileHere:=FileExist(PlyrFile)

	fAssign(PlyrFilePtr,PlyrFile,66)
	If FileHere Then
		fReset(PlyrFilePtr)
	Else
		fRewrite(PlyrFilePtr)

	fSeek(PlyrFilePtr,SizeOf(Sane)*(PIdx-1))
	If IoResult <> 0 Then
		Ret:=0
	Else Begin

                If OP1 = P Then Sane:=Plyr //P2S
                If OP1 = O then Sane:=Othr //O2S
		If OP1 = S Then Begin End
                        
		fWrite(PlyrFilePtr,Sane,SizeOf(Sane))

		fClose(PlyrFilePtr)
		Ret:=1
	End
	SavePlyr:=Ret
End

Procedure ReadBull
Begin
	DispFile(BulletFile)
	If Not FileExist(BulletFile) Then Begin
		WriteLn('|CR|07No LLL Bulletin Today.')
	End
	Paws
End

Function IncStr(Str1 : String; Amt1 : Integer) :String
Begin
	IncStr:=Int2Str(Str2Int(Str1)+Amt1)
End

Function DecStr(Str1 : string; Amt1 : Integer) :String
Begin
	DecStr:=Int2Str(Str2Int(Str1)-Amt1)
End

Procedure WriteBull
Var T1	: Array[1..4] of String
Var I5  : Integer
Begin
	WriteLn('|CR|11Enter four lines:')
	For I5:=1 to 4 do Begin
		Write('|11: ')
		T1[I5]:=Input(75,75,11,'')
	End
	If Not InputYN('|CR|10Is this okay? ') Then 
		WriteLn('|CR|11Nothing Saved.');
	Else Begin
                fAssign(F4,BulletFile,66)
                fReWrite(F4)
		fWriteLn(F4,'|14LLL Bulletin Announced by: ' + Plyr.Name)
		fWriteLn(F4,'')
		For I5:=1 to 4 Do Begin
			fWriteLn(F4,T1[I5])
		End
		fClose(F4)
		WriteLn('|CR|10Bulletin Saved.')
	End
	Paws
End

Procedure LLLBull
Var C1 :	Char
Begin
	C1:=''
	While C1 <> 'Q' Do Begin
		ClrScr	
		WriteLn('|CR|11The LLL Bulletin:|CR')
		WriteLn('Options: ')
		WriteLn(' |10[|11L|10] |11Listen to bulletin')
		writeLn(' |10[|11W|10] |11Write Bulletin')
		WriteLn(' |10[|11Q|10] |11Quit')
		Write  ('|CR|11Which (|10L,W,Q|11) : ' )
		C1:=OneKey('LWQ',True)
		If C1 = 'L'	Then ReadBull	
		If C1 = 'W'	Then WriteBull
	End
End

Procedure InitPlyr (PC :Integer)
Begin
	Plyr.Idx:=PC
	Plyr.Name:=UserAlias
	Plyr.Alias:=UserAlias
	Plyr.LastOn:=DateTime
	Plyr.Weap:='Dumb Terminal'
	Plyr.Arm:='None'
	Plyr.WeapNo:=1
	Plyr.ArmNo:=1
	Plyr.Lev:=1
	Plyr.Dl:=10
	Plyr.Money:=10
	Plyr.Bank:=0
	Plyr.Runs:=3
	Plyr.Calls:=10
	Plyr.Fights:=3
	Plyr.Hp:=10
	Plyr.Megs:=10
	Plyr.Rank:=1
	Plyr.Troj:=1
	Plyr.FBu:=1
End

Procedure ParseItem ( Line :String )
Var Front	:String
Var Back	:String
Var Idx		:Integer
Var Cnt		:Integer
Begin
	Front:=Line
	Back:=Line
	Cnt:=1
	Repeat
		Idx:=Pos(':',Front)
		If Idx > 0 Then Begin
			Delete(Front,Idx,Length(Front)-Idx+1)
			Delete(Back,1,Idx)
		End
		Case Cnt Of
			1 : GNum:=Str2Int(Front)
			2 : GStr:=Str2Int(Front)
			3 : GPrice:=Str2Int(Front)
			4 : GWep:=Front
			5 : GArm:=Front
		End
		Front:=Back
		Cnt:=Cnt+1
	Until Idx = 0 
End

Function ReadItem(RecNo :Integer ) : Integer
Var Ok		:Integer
Var Ttxt1	:String	
Begin
	Ok:=1
	If fileExist(ItemFile) Then Begin
		fAssign(ItemFilePtr,ItemFile,66)
		freset(ItemFilePtr)
		I2:=1
		While I2 <= RecNo and not Feof(ItemFilePtr) do Begin
			fReadLn(ItemFilePtr,Ttxt1)
			Ok:=1
			I2:=I2+1
		End
		fClose(ItemFilePtr)
		If I2 = RecNo + 1 then
			ParseItem(Ttxt1)
	End
	ReadItem:=Ok
End

Function Robank3 : LongInt
Var L1 :LongInt
Var I5 :Integer
Begin
	L1:=0
	I5:=1
	While ReadSane(I5)=1 Do Begin
                Othr:=Sane // S2O
                If Othr.Idx<>Plyr.Idx Then Begin
			L1:=L1+Othr.Bank
                        Othr.Bank:=0
                        SavePlyr(Othr.Idx,O)

		End
		I5:=I5+1
	End
	Robank3:=L1
End

Procedure Robank2
Var jkl	:Integer
Var jll	:Integer
Var T2T :LongInt
Begin
	jkl:=Plyr.Dl*10
	jkl:=jkl/10
	If Jkl<2 then jkl:=2 
	jll:=Random(jkl)
	If Jll=1 Then Begin
		T2T:=RoBank3
		Plyr.Money:=Plyr.Money+T2T
		WriteLn('|CR|14You successfully hacked out cards!')
		WriteLn('|06You transferred |14$' + Int2Str(T2T) + '|06 to your account!')
	End
	If Jll<>1 Then Begin
		WriteLn('|CR|14You were caught.  |06The LLL now requires you to crash more harddrives to make')
		WriteLn('another level.')
		Plyr.Dl:=Plyr.Lev*5
	End
        SavePlyr(Plyr.Idx,P)
	Paws
End

Procedure Robank
Begin
	WriteLn('|CR|11Failing to hack out the credit cards will get the LLL *MAD*.')
	If Times>=3 Then Begin
		WriteLn('|CR|12Sorry, you can only try to hack the')
		WriteLn('cards 3 times.|11')
	End
	If Times < 3 Then Begin
		If Not InputYN('|CR|10Still hack? ') Then
			WriteLn('|CR|12Aborted.')
		Else Begin
			Times:=Times+1
			Robank2
		End
	End
End

Function MakeRank(UIdx :Integer) : Integer
Var Highest 	: Byte = 0
Var I5,I7	: Byte
Var B1		: Boolean
Var Ret1 :Integer
Begin
	I7:=1
	For I5:=30 Down to 1 Do Begin
		B1:=False
		For I6:=1 To PlyrCnt Do Begin
			If ReadSane(I6) = 1 Then Begin
				If Sane.Lev = I5 Then Begin
					Sane.Rank:=I7
					SavePlyr(Sane.Idx,S)
					B1:=True
				End
			End	
		End
		If B1 Then
			I7:=I7+1
	End
	
	MakeRank:=Ret1
End

Procedure CountPlyrs
Begin
        PlyrCnt:=1
	While ReadSane(PlyrCnt) = 1 Do Begin
		PlyrCnt:=PlyrCnt+1
	End
	PlyrCnt:=PlyrCnt-1
End

Procedure HSpell
Begin
End

Procedure Fight2
Var hta		:LongInt
Var htb		:LongInt
Var htc		:LongInt
Var hthm	:LongInt
Var htyu	:LongInt
Var PA		:Integer
Var OA		:Integer
Var PW		:Integer
Var OW		:Integer
Var PH		:Integer
Var OH		:Integer
Begin
	hta:=random(10)
	htb:=random(10)
	htc:=random(10)
	PW:=Plyr.WeapNo
	PA:=Plyr.ArmNo
	OW:=Othr.WeapNo
	OA:=Othr.ArmNo
	PH:=Plyr.Megs
	OH:=Othr.Megs
	hthm:=PW*Hta
	hthm:=hthm/OA
	htyu:=OW*htb
	htyu:=htyu/PA
	If hthm>=1 Then
                WriteLn('|CRYou trash ' + Int2Str(hthm) + ' megs!')
	else
		WriteLn('|CRYou got line noise!')
	OH:=OH-hthm
	Othr.Megs:=OH

	If htyu>=1 Then
		WriteLn('They purge ' + Int2Str(htyu) + ' megs!')
	Else
		WriteLn('They deleted an EMPTY directory!')
	PH:=PH-htyu
	If HtC=6 Then
		HSpell
	Plyr.Megs:=PH
End

Procedure UpDa2
Var L1	:Integer
Var L2	:Integer
Var G1	:Integer
Var G2	:Integer
Var T1  :Integer
Var TX  :String
Var I5  :Integer
Begin
	Othr.Money:=0
	L1:=Plyr.Lev
	L2:=Othr.Lev
	G1:=Plyr.Dl
	G2:=Othr.Dl
	If L1 >= L2 Then Begin
		I5:=L2*3
		G1:=G1-I5
		If G1>0 Then
			WriteLn('|CR|10The LLL is proud and will give you credit for this.')
		If G1<=0 Then
			WriteLn('|CR|10The LLL couldn''t be more proud!  They promote you a level!')
		Plyr.dl:=G1
                SavePlyr(Plyr.Idx,P)
	End
	If L1<L2 Then Begin
		T1:=Plyr.Lev
		Plyr.Lev:=Othr.Lev
		Othr.Lev:=T1
		I5:=G1
		I2:=L1	
		G1:=G2
		L1:=L2
		G2:=I5
		L2:=I2
		Plyr.Dl:=G1	
		Plyr.Lev:=L1
		WriteLn('|CR|10The LLL promotes you to level |11' + Int2Str(Plyr.Lev) + '|10!')
		WriteLn('|11They demote him to level |10' + Int2Str(Othr.Lev) + '|11!')
                SavePlyr(Plyr.Idx,P)
                SavePlyr(Othr.Idx,O)
	End
	If Plyr.WeapNo <= Othr.WeapNo Then Begin
		WriteLn('|CR|10You downloaded his software!')
		TX:=Plyr.Weap
		Plyr.Weap:=Othr.Weap
		Othr.Weap:=TX
		T1:=Plyr.WeapNo
		Plyr.WeapNo:=Othr.WeapNo
		Othr.WeapNo:=T1
                SavePlyr(Plyr.Idx,P)
                SavePlyr(Othr.Idx,O)
	End
	If Plyr.ArmNo <= Othr.ArmNo Then Begin
		WriteLn('|CR|10You stole his backup!')
		Tx:=Plyr.Arm
		Plyr.Arm:=Othr.Arm
		Othr.Arm:=Tx
		T1:=Plyr.ArmNo
		Plyr.ArmNo:=Othr.ArmNo
		Othr.ArmNo:=T1
                SavePlyr(Plyr.Idx,P)
                SavePlyr(Othr.Idx,O)
	End
End

Procedure UpDa
Var L1	:LongInt
Var V1	:Integer	
Var V2	:Integer	
Var G1	:Integer
Var T1  :Integer
Var Tx	:String
Begin
	L1:=Othr.Money + Plyr.Money
	Plyr.Money:=0
	V1:=Plyr.Lev
	V1:=V1*3
	G1:=Othr.Dl
	G1:=G1-V1
	If G1 <= 0 Then Begin
		V2:=Othr.Lev
		V2:=V2+1
		Othr.Lev:=V2
		G1:=V2*10
		Othr.Dl:=G1
                SavePlyr(Othr.Idx,P)
                SavePlyr(Plyr.Idx,O)
	End
	G1:=Othr.WeapNo
	V1:=Plyr.WeapNo
	If G1<V1 Then Begin
		WriteLn('|CRHe downloaded your software!')
		t1:=Othr.WeapNo
		Othr.WeapNo:=Plyr.WeapNo
		Plyr.WeapNo:=t1
                SavePlyr(Plyr.Idx,P)
                SavePlyr(Othr.Idx,O)
	End
	G1:=Othr.ArmNo
	V1:=Plyr.ArmNo
	If G1<V1 Then Begin
		WriteLn('|CRHe stole your backup!')
		t1:=Othr.ArmNo
		Othr.ArmNo:=Plyr.ArmNo
		Plyr.ArmNo:=t1
                SavePlyr(Plyr.Idx,P)
                SavePlyr(Othr.Idx,O)
	End
End

Procedure YouDead
Var L1	:LongInt
Var L2	:Integer	
Begin
	L1:=Plyr.Money
	L1:=L1/2
	WriteLn('|CRThere goes your hard disk!')
	If Guf = 0 Then Upda
	If Guf = 1 Then Plyr.Money:=L1 	
	L2:=Plyr.Lev
	If L2 > 30 Then Begin
		Plyr.Lev:=30
		Plyr.Dl:=300
	End
	Plyr.Megs:=0
        SavePlyr(Plyr.Idx,P)
End

Procedure MakeScores 
Var J1	:Integer
Var TTXT1	:String
Var Nm  : String
Var ix  : Integer
Begin
	If fileExist(ScoresFile) Then
		FileErase(ScoresFile)
	fAssign(F4,ScoresFile,66)
	fReWrite(F4)
	fWriteLn(F4,'|CL|06.:|14[ |11'+ProgName+' '+ProgVer+'|06, a Mystic program, |06'+ProgAuth+'|CR')
	fWriteLn(F4,'|11Player List|CR')
	fWriteLn(F4,'|10## Rank Lev LastOn     Name')
	fWriteLn(F4,'-- ==== --- ========   ------------------------------------|11')

	Num:=1
	While ReadSane(Num) = 1 Do Begin
		Othr:=Sane // S2O
                Nm:=Othr.Name
                Ix:=Othr.Idx
		If Odd(Num) Then TTxt1:='|15' Else TTxt1:='|07' 
		TTxt1:=TTxt1+PadLt(Int2Str(Ix),2,' ') + ' '
                TTxt1:=TTxt1+PadLt(Int2Str(Othr.Rank),4,' ') + ' '
                TTxt1:=TTxt1+PadLt(Int2Str(Othr.Lev),3,' ') + ' '
                TTxt1:=TTxt1+PadRt(DateStr(Othr.LastOn,1),10,' ') + ' '
		If Odd(Num) Then TTxt1:=TTxt1+'|06' Else TTxt1:=TTxt1+'|14' 
		TTxt1:=TTXt1+Nm
		fWriteLn(F4,TTxt1)
		Num:=Num+1
	End
	fWriteLn(F4,'|CR|PA')
	fClose(F4)
End

Procedure MLev
Var L1	:Integer
Begin
	Plyr.Lev:=Plyr.Lev+1
	Plyr.Dl:=(Plyr.Lev*10)+Plyr.Lev
	WriteLn('|CR|10The LLL is please with this performance.  You are now level |11'+ Int2Str(Plyr.Lev) + '|10!')
	Plyr.HP:=Plyr.dl
	Plyr.Megs:=Plyr.HP

	If Plyr.Troj < 0  Then Plyr.Troj := 0
	If Plyr.Troj > 30 Then Plyr.Troj := 30
	If Plyr.FBu < 0  Then Plyr.FBu := 0
	If Plyr.FBu > 30 Then Plyr.FBu := 30
	Plyr.Calls:=0
        SavePlyr(Plyr.Idx,P)
	MakeScores
	WriteLn('|CR|10You must leave now')
	halt
End

Procedure TheyDead
Begin
	WriteLn('|CRTheir computer is FRIED!')
	WriteLn('|CRAnd look!  Here''s his credit card # with $' + Int2Str(Othr.Money) + ' in the account!')
	Plyr.Money:=Plyr.Money+Othr.Money
	If Guf = 0 Then UpDa2
	If Guf = 1 Then	Plyr.Dl:=Plyr.Dl-Num
	If Plyr.Dl <= 0 Then	MLev 
        SavePlyr(Plyr.Idx,P)
End

Procedure Trojan
Var JI	:Integer
Begin
	If Plyr.Troj <=0 Then
                WriteLn('|CR|12OOOPS!  You accidentally erased it!|11')

	If Plyr.Troj > 0 Then Begin
		Plyr.Troj:=Plyr.Troj-1
		JI:=Random(5)*Plyr.WeapNo
                WriteLn('|11You upload a trojan horse|DE.|DE.|DE.')
		WriteLn('|CRThe idiot runs it!  '+Int2Str(JI) + ' megs are trashed!')
		Othr.Megs:=Othr.Megs-JI
	End
End

Procedure RestoreFiles
Var Ji	:Integer
Begin
	If Plyr.FBu < 1 Then Begin
		WriteLn('|CRThe files were completely purged!')
		Plyr.FBu:=0
	End Else Begin
		Plyr.FBu:=Plyr.FBu-1
		JI:=Random(5)*Plyr.ArmNo
		WriteLn('|CRYou run a backup packup program|DE.|DE.|DE.')
		If Plyr.Megs+JI >= Plyr.hp Then 
			WriteLn('|CRYou recover all of your megs back!')
		Else
			WriteLn('|CRYou recover ' + Int2Str(Ji) + ' megs back!')
		Plyr.Megs:=Plyr.Megs+JI
		If Plyr.Megs > Plyr.hp Then 
			Plyr.Megs:=Plyr.hp
	End
        SavePlyr(Plyr.Idx,P) 
End

Procedure Fight
Var C1 : Char
Var I5 : Integer
Begin
	Done1:=False
	Run:=0
        WriteLn('|CR|13You begin to hack!|CR')
	While not done1 Do Begin
                WriteLn('|CR|13You have |12' + Int2Str(Plyr.Megs) + '|13 megs left.')
                WriteLn('|13They have |12' + Int2Str(Othr.Megs) + '|13 megs left.')
                Write  ('|CR|13[|12T|13]rash Files, [|12D|13]rop Carrier, [|12U|13]pload Trojan Horse, or [|12B|13]ackup Files: |11')
		C1:=OneKey('TDUB',True)
		Case C1 Of
			'T' 	: Fight2	
			'D'	: Run:=1
			'U'	: Trojan
			'B'	: RestoreFiles
		End
		I5:=Plyr.Megs
		I4:=Othr.Megs
		If I5 <=0 or I4 <=0 or C1 = 'D' Then
			Done1:=True
	End
	If Plyr.Megs <=0	Then	
		YouDead		
	Else 
		If Othr.Megs <=0	Then	
			TheyDead	
		Else 
			If	Run=1 Then
				WriteLn('|CR|11NO CARRIER|CR')
End

Procedure FBat
Begin
	ClrScr	
	WriteLn('|CRCongratulations, ' + Plyr.Name +'!')
	WriteLn('You have become a level 31 leech!  Now time for the BIG challenge.')
	WriteLn('You have to crash the LLL computer!  Yes, you have all of your megs back,')
	WriteLn('but you''ll need them against the LLL.  If you fail, the LLL will be mad.')
	WriteLn('and demote you to level 30.  Good luck!')
	Paws
	Othr.HP:=360
	Plyr.HP:=310
	Othr.WeapNo:=Plyr.WeapNo
	Othr.ArmNo:=Plyr.ArmNo
	Fight
	If Run=1 Then Begin
		WriteLn('|CRThe LLL is pissed.  Go back and repeat level 30!')
		Plyr.Lev:=30
		Plyr.Dl:=300
                SavePlyr(Plyr.Idx,P)
	End
	If Run<>1 Then Begin
		WriteLn('|CRThe LLL''s computer is done for!  They enter you into the leech hall of fame!')
		fAssign(F4,CfgTextPath+'hallfame.lch',66)	
		fseek(F4,fsize(f4))
		fWriteLn(F4,Plyr.Name)
		fClose(F4)
		If fileexist(PlyrFile) then Begin
			fileerase(PlyrFile)
			WriteLn('|CR|12|23The Game has been rerolled!')
			WriteLn('|CR|09|23Now returning to an environment with even WORSE users...|08|16')
			paws
			halt
		End
	End
End

Procedure ListPlyrs
Begin
	MakeRank(Plyr.Idx)
	MakeScores
	DispFile(ScoresFile)
End

Procedure Examine 
Var UStr	:String
Var TStr	:String
Var Cstu	:Integer
Var I5		:Integer
Begin
	Cstu:=Plyr.Lev * 10
	Write('|CR|11Name (Or Partial) of Leech to Examine: ')
	UStr:=Input(30,30,12,'')
	If UStr = '?' Then
		ListPlyrs
	Else Begin
		I5:=1
		While ReadSane(I5) = 1 Do Begin
			TStr:=Upper(Othr.Name)
			If Pos(UStr,TStr) > 0  and Othr.Name <> Plyr.Name Then Begin
				If InputYN('|CR|11Do you mean |14' + Othr.Name + '|11? ') Then Begin
					If InputYN('|CR|10Are you aware that it will cost you $' + Int2Str(cstu) + '? ') Then Begin
						If Plyr.Money >= Cstu Then Begin
							Plyr.Money:=Plyr.Money-Cstu
                                                        SavePlyr(Plyr.Idx,P)
							WriteLn('|CR|10Leech  |12:   |11#' + Int2Str(Othr.Idx) + ' ' + Othr.Name)
							WriteLn('|10Level     |12:    |11' + Int2Str(Othr.Lev))
							WriteLn('|10Rank      |12:    |11' + Int2Str(Othr.Rank))
							WriteLn('|10Software  |12:    |11' + Othr.Weap)
							WriteLn('|10Backup    |12:    |11' + Othr.Arm)
							WriteLn('|10Money     |12:    |11' + Int2Str(Othr.Money))
							WriteLn('|10Megs Left |12:    |11' + Int2Str(Othr.Lev*10) + '(' + Int2Str(Othr.Lev*10) + ')')
						End
						If Plyr.Money < Cstu Then Begin
							WriteLn('|CRYou can''t afford to do that!')
							Paws	
						End
					End
				End
			End
			I5:=I5+1
		End
	End
	Paws
End

Procedure Call
Var Ttxt1	:String
Begin
	If Plyr.Calls > 0 then
		Plyr.Calls:=Plyr.Calls-1
	Else Begin
		WriteLn('|CROveruse error.')
		exit
	End
	WriteLn('|CL|11Welcome to ' + Plyr.Weap + '!')
	Num:=0
	Repeat
		Write('|11Which BBS to call? (? for list) : ')
		Ttxt1:=Input(3,3,12,'')
		If Ttxt1 = '?' Then
			DispFile('bbs.lch')	
		Num:=Str2Int(Ttxt1)
	Until Num > 0 and Num < 100
	If Num>=1 Then Begin
		WriteLn('|11Dialing|DE.|DE.|DE.|CR')
		WriteLn('|11CONNECT')
		Plyr.Fights:=Plyr.Fights-1
		Othr.Megs:=Num*7
		Othr.Money:=Num*60
		Othr.WeapNo:=Num
		Othr.ArmNo:=1
		Guf:=1
		Fight
	End
	If Num<1 Then 
		WriteLn('|CRAborted.')
End

Procedure HealW
Begin
	I6:=Plyr.Lev*4
	If Plyr.Money<I6*Num Then Begin
		Num:=Plyr.Money/I6
		If Num < 1 Then 
			Num:=0
	End
	Plyr.Money:=Plyr.Money-(I6*Num)
	Plyr.Megs:=Plyr.Megs+Num
	WriteLn('|CR|02You recover |10' + Int2Str(Num) + '|02 megs!|11')
End

Procedure Doctor
Var I5	:Integer
Var I8  :Integer
Begin
	I5:=Plyr.hP-Plyr.Megs
	I6:=Plyr.Lev*4
	I8:=Plyr.Money/I6
	WriteLn('|CL|02You have |10' + Int2Str(I5) + '|02 deleted megs.')
	WriteLn('It will cost |10$'+ Int2Str(I6) + '|02 to recover each meg.')
	WriteLn('You can afford to recover |10'+ Int2Str(I8) + '|02 megs.')
	Write  ('|CRUnerase [|10A|02]ll or [|10S|02]ome megs? : |11')
	CX:=OneKey('AS',True) 
	If CX = 'A' Then Begin
		Num:=I5
		HealW
	End Else Begin
		Repeat
                        Write('|CR|02How many megs to unerase? [|10'+Int2Str(I8)+' Max|02] : |11')
                        Num:=Str2Int(Input(3,3,2,''))
		Until Num >= 0 or Num<=I5
		If Num > 0 Then
			HealW
		Else
			WriteLn('|CR|04Aborted.|11')
	End
        SavePlyr(Plyr.Idx,P)
End

Procedure Hack
Var UStr	:String
Var TStr	:String
Var M1		:Integer
VAr I5		:Integer
Begin
	If Plyr.Fights > 0 then
		Plyr.Fights:=Plyr.Fights-1
	If Plyr.Fights <= 0 then Begin
		WriteLn('|CROveruse error.')
		Exit
	End
	Guf:=0
	If Plyr.Fights > 0 Then Begin
		Write('|CRName (Or Partial) of Leech to Hack : ')
		UStr:=Input(30,30,12,'')
		If UStr = '?' Then
			ListPlyrs
                Else Begin
			I5:=1
			While ReadSane(I5) = 1 Do Begin
                                TStr:=Upper(Sane.Name)
                                If Pos(UStr,TStr) > 0  and Sane.Name <> Plyr.Name Then Begin
                                        If InputYN('|CR|11Do you mean |14' + Sane.Name + '|11? ') Then Begin
                                                Othr:=Sane // S2O
						Othr.Megs:=Othr.HP
						Sane:=Othr // O2S
                                                SavePlyr(Othr.Idx,O)
						Fight
					End
				End
				I5:=I5+1
			End
		End
	End
	If Plyr.Fights <= 0 Then 
		WriteLn('|CRYou have used up all your fights for today.')
End


Function FindPlyr(Strg :String):Integer
Var RetNo	:Integer	
Var X1		:Integer
Begin
	RetNo:=-2
	X1:=1
	While ReadSane(X1) = 1 Do Begin
		If Sane.Name = Strg Then Begin
			Plyr:=Sane // S2P
			RetNo:=Sane.Idx
		End
		X1:=X1+1
	End
	FindPlyr:=RetNo
End

Procedure UserEdit
Var I8:Integer
Begin
	If ACS('s255') Then Begin
		I8:=1
		While ReadSane(I8) = 1 Do Begin
                        Write(PadLt(Int2Str(Sane.Idx),4,' ')+' ')
                        WriteLn(PadRt(Sane.Name,20,' '))
			I8:=I8+1
		End
		paws
	End
End

Procedure InitGame
Var I5	: Integer
Begin
	
	PlyrFile:=CfgDataPath+PlyrFileName
	ItemFile:=CfgDataPath+ItemFileName
	ScoresFile:=CfgTextPath+'scor3.ans'
	BulletFile:=CfgTextPath+'scor4.ans'
	Times:=0
	Today:=DateStr(DateTime,1)
	I5:=-2
	CountPlyrs
	If PlyrCnt > 0 Then Begin
		I5:=FindPlyr(UserAlias) 
	End
	If I5 < 0 Then Begin
		WriteLn('|CL|12|23Hello, new leech!|CR|PA|11|16')	
		PlyrCnt:=PlyrCnt+1
		InitPlyr(PlyrCnt)
                SavePlyr(Plyr.Idx,P)
		WriteLn('PlyrCnt='+Int2Str(PlyrCnt))
		WriteLn('Plyr.Idx ='+Int2Str(Plyr.Idx))
		WriteLn('Plyr.Name='+Plyr.Name)
	End
	If I5 > 0 Then Begin
		If ReadSane(I5) < -1 then 
			WriteLn('Error reading player record.')
		Else Begin
			WriteLn('|CR|11Welcome Back, ' + Plyr.Name)
			If DateStr(Plyr.Laston,1) <> today then Begin
				Plyr.Runs:=3
				Plyr.Troj:=Plyr.Lev
				Plyr.FBu:=Plyr.Lev
			End
			Plyr.Fights:=Plyr.Lev
			Plyr.Calls:=Plyr.Lev+3
			Plyr.Megs:=Plyr.HP
			Plyr.LastOn:=DateTime
                        SavePlyr(Plyr.Idx,P)
		End
	End
End

Procedure Cruns
Var I5	:Integer
Begin
	I5:=Plyr.Runs
	If I5 < 1 Then Begin
		WriteLn('|11Hey, you ARE a leech!  Only 3 times per day!|11')
		Paws
		If ACS('s255') then
			WriteLn('|CRBut since you are GOD, you can play.|11')
		Else
			Halt
	End
	If I5 >= 1 Then Begin
		If I5 > 0 Then Begin
			Plyr.Runs:=Plyr.Runs-1
			Plyr.Megs:=Plyr.HP
                        SavePlyr(Plyr.Idx,P)
		End
		WriteLn('|CL|05|16Glad to see you back, '+ Plyr.Name + '!|11')
		Paws
	End
End

Procedure Status
Begin
	Clrscr
	MakeRank(Plyr.Idx)
	WriteLn('|10Leech                   |11#' + Int2Str(Plyr.Idx) + ' ' + Plyr.Name)
	WriteLn('|10Level                   |11' + Int2Str(Plyr.Lev))
	WriteLn('|10Rank                    |11' + Int2Str(Plyr.Rank))
	WriteLn('|10Software                |11' + Plyr.Weap)
	WriteLn('|10Backup                  |11' + Plyr.Arm)
	WriteLn('|10Drives Left to Crash    |11' + Int2Str(Plyr.Dl))
	WriteLn('|10Money                  $|11' + Int2Str(Plyr.Money))
	WriteLn('|10Money in LLL Account   $|11' + Int2Str(Plyr.Bank))
	WriteLn('|10Games Left Today        |11' + Int2Str(Plyr.Runs))
	WriteLn('|10Fast Backups Left       |11' + Int2Str(Plyr.FBu))
	WriteLn('|10Trojan Horses Left      |11' + Int2Str(Plyr.Troj))
	WriteLn('|10Calls to BBSes Left     |11' + Int2Str(Plyr.Calls))
	WriteLn('|10Calls to Leeches  Left  |11' + Int2Str(Plyr.Fights))
	WriteLn('|10Megs Left               |11' + Int2Str(Plyr.Megs) + ' |10(|11' + Int2Str(Plyr.HP) + '|10)')
End


Procedure AddBank
Begin
	Plyr.Bank:=Plyr.Bank+Plyr.Money
	Plyr.Money:=0
        SavePlyr(Plyr.Idx,P)
	WriteLn('|CR|11$' + Int2Str(Plyr.Bank) + ' now in LLL Account..')
End

Procedure SubBank
Begin
	Plyr.Money:=Plyr.Money+Plyr.Bank
	Plyr.Bank:=0
        SavePlyr(Plyr.Idx,P)
	WriteLn('|CR|11$' + Int2Str(Plyr.Money) + ' now in possession.  $0 in LLL Account.')
End

Procedure ListArmor
Var A1	:Integer
Var B1	:LongInt	
Begin
	A1:=1
	B1:=0
	WriteLn('|10Num: Strength  Price     Armor') 
	WriteLn('|10---- --------  --------- ------------------|11')
	While ReadItem(A1) = 1 and A1 <= 15 Do Begin
		If Plyr.Money >= B1 Then Begin
			Write  (PadLt(Int2Str(GNum),3,' ') + ': ' )
			Write  (PadRt(Int2Str(GStr),8,' ') + ' $' )
			WriteLn(PadLt(Int2Str(GPrice),9,' ') + ' ' + GArm)
			B1:=GPrice
		End
		A1:=A1+1
	End
	WriteLn('|10---- --------  --------- ------------------')
	WriteLn('|11You have $'+Int2Str(Plyr.Money))
End

Procedure SellArmor
Begin
	If ReadItem(Plyr.ArmNo) <> 1 Then
		WriteLn('|CR|12Error reading Armor Record')
	Else Begin
		WriteLn('|CR|11You can sell your |10' + GArm + '|11 for |10$' + Int2Str(GPrice/2) + '|11.')
		If Not InputYN('Do you wish to do so? ') Then
			WriteLn('|CR|12Aborted.')
		Else Begin
			WriteLn('|CR|10Backup Sold!')
			Plyr.Arm:='None'
			Plyr.ArmNo:=1
			Plyr.Money:=Plyr.Money+GPrice/2
                        SavePlyr(Plyr.Idx,P)
		End
	End
End

Procedure BuyArmor
Var Ttxt	:String
Var L1		:LongInt
Begin
	L1:=Plyr.Money
	ListArmor
	Done1:=False
	While Not Done1 Do Begin
		Write('|CR|11Enter number of backup you wish to buy: ')
		Num:=Str2Int(input(2,2,12,''))
		If Num <1 or Num >15 Then 
			Done1:=True
		Else Begin
			If ReadItem(Num) <> 1 Then 
				WriteLn('|CR|12Invalid Amount!  Try again!')
			Else Begin
				WriteLn('|CR|11A |10' + GArm + '|11 costs |10$' + Int2Str(GPrice) + '|11.')
				If Not InputYN('|11Do you wish to purchase it? ') Then
					WriteLn('|CR|10Aborted.')
				Else Begin
					If L1 < GPrice Then
						WriteLn('|CR|12That price is over your savings!')
					Else Begin
						WriteLn('|CR|10Backup bought.')
						Plyr.Arm:=GArm
						Plyr.ArmNo:=GNum
						Plyr.Money:=Plyr.Money-GPrice
                                                SavePlyr(Plyr.Idx,P)
						Done1:=True
					End 
				End
			End
		End
	End
End

Procedure ShopArmor
Begin
	Ch2:=''	
	While Ch2 <> 'Q' Do Begin
		Clrscr
		WriteLn('|11LLL Backup Shop|CR')
		WriteLn('|11Options: ')
		WriteLn(' |11[|10B|11] Buy Backup')
		WriteLn(' |11[|10S|11] Sell Backup')
		WriteLn(' |11[|10L|11] List Backup')
		WriteLn(' |11[|10Q|11] Quit')
		Write('|CR|11Which (|10B,L,S,Q,?|11) : ')
		Ch2:=OneKey('BSLQ',True)
		Case Ch2 Of
			'B': Begin 
				BuyArmor	
				Paws
			     End
			'L': Begin 
				ListArmor	
				Paws	
		   	     End
			'S': SellArmor
		End
	End
End

Procedure ListWeapon
Var A1	:Integer
Var B1	:LongInt
Begin
	A1:=1
	B1:=0
	WriteLn('|11Num: Strength  Price     Weapon') 
	WriteLn('|11---- --------  --------- ------------------|10')
	While ReadItem(A1) = 1 and A1 <= 15 Do Begin
		If Plyr.Money >= B1 Then Begin
			Write  (PadLt(Int2Str(GNum),3,' ') + ': ' )
			Write  (PadRt(Int2Str(GStr),8,' ') + ' $' )
			WriteLn(PadLt(Int2Str(GPrice),9,' ') + ' ' + GWep)
			B1:=GPrice
		End
		A1:=A1+1
	End
	WriteLn('|11---- --------  --------- ------------------')
	WriteLn('|10You have $'+Int2Str(Plyr.Money))
End

Procedure SellWeapon
Begin
	If ReadItem(Plyr.WeapNo) <> 1 Then
		WriteLn('|CR|12Error reading Software Record')
	Else Begin
		WriteLn('|CR|11You can sell your |10' + GWep + '|11 for |10$' + Int2Str(GPrice/2) + '|11.')
		TF:=InputYN('|11Do you wish to do so? ') 
		If Not TF Then
			WriteLn('|CR|12Aborted.')
		Else Begin
			WriteLn('|CR|10Software Sold!')
			Plyr.Weap:='None'
			Plyr.WeapNo:=1
			Plyr.Money:=Plyr.Money+(GPrice/2)
                        SavePlyr(Plyr.Idx,P)
		End
	End
End


Procedure BuyWeapon
Var Ttxt	:String
Var L1		:LongInt
Begin
	L1:=Plyr.Money
	ListWeapon
	Done1:=False
	While not done1 Do Begin
		Write('|CR|10Enter number of Software you wish to buy: |11')
		Num:=Str2Int(input(2,2,12,''))
		If Num < 1 or Num >15 Then
			Done1:=True
		Else Begin
			If ReadItem(Num)<>1 Then 
				WriteLn('|CR|12Invalid Amount!  Try again!')
			Else Begin
				WriteLn('|CR|11A |10' + GWep + '|11 costs |10$' + Int2Str(GPrice) + '|11.')
				TF:=InputYN('|11Do you wish to purchase it? ') 
				If Not TF Then
					WriteLn('|CR|12Aborted.')
				Else Begin
					If L1 < GPrice Then
						WriteLn('|CR|12That price is over your savings!')
					Else Begin
						WriteLn('|CR|10Software bought.')
						Plyr.Weap:=GWep
						Plyr.WeapNo:=GNum
						//Plyr.Money:=L1-GPrice
						Plyr.Money:=Plyr.Money-GPrice
                                                SavePlyr(Plyr.Idx,P)
						Done1:=True
					End 
				End
			End
		End
	End
End

Procedure ShopWeapon
Begin
	Ch2:=''	
	While Ch2 <> 'Q' Do Begin
		ClrScr
		WriteLn('|10LLL Software Shop|CR')
		WriteLn('|10Options: ')
		WriteLn(' |11[|10B|11] Buy Software')
		WriteLn(' |11[|10S|11] Sell Software')
		WriteLn(' |11[|10L|11] List Software')
		WriteLn(' |11[|10Q|11] Quit')
		Write('|CR|11Which (|10B,L,S,Q,?|11) : ')
		Ch2:=OneKey('BSLQ',True)
		Case Ch2 of
			'B' : BuyWeapon
			'L' : Begin 
				ListWeapon 
				Paws 
				End
			'S' :SellWeapon
		End
	End
End

Procedure LLL
Begin
	If Plyr.Lev>30	Then Fbat	
	ClrScr
	WriteLn('|CR|11Dialing LLL|DE.|DE.|DE.|DECONNECT|CR')
	Ch1:=''
	While Ch1 <> 'Q' Do Begin
		DispFile('lllmenu.lch')
		WriteLn('|10Welcome to the Lame Local Leeches BBS!')
		Write('|CR|11Command (? for Help): ')
		Ch1:=Onekey('DQHCLEGBS?',True)
		Case Ch1 of
			'Q' : WriteLn('|CRNO CARRIER')
			'D' : Begin
				DispFile('hallfame.lch')	
				Write('|CR|PA')
				End
			'L' : ListPlyrs
			'H' : ShopArmor	
			'S' : ShopWeapon
			'E' : Examine	
			'B' : LLLBull
			'C' : Robank	
		End
	End
End

Procedure Format
Begin
	If Not InputYN('|CRFormat Harddrive -- will erase all stats.  Sure? ') Then
		WriteLn('|CRAborted.')
	Else Begin
		InitPlyr(Plyr.Idx)
		WriteLn('|CR|20Harddrive formatted!|11')
	End
End

Begin
	GetThisUser
	SysopLog(UserAlias+' Played LEECH')

	MenuCmd('NA','Mystic Leech')
	ClrScr
	DispFile('opening.lch') paws

	InitGame

	Cruns

	ReadBull

	Done:=False
	DispFile('ibmmenu.lch')
	While Not Done Do Begin
		WriteLn('|CR|10(?=Help)')
		Write('|11C:\> ')
		iStr:=Input(10,10,2,'')
		Case iStr Of
			'QUIT' 		: Done:=True 
			'EXIT' 		: Done:=True 
			'Q' 		: Done:=True 
			'FORMAT'	: Format 
			'STATUS'	: Status	
			'LIST'		: ListPlyrs
			'HACK'		: Hack 
			'CALL'		: Call 
			'LLL'		: LLL 
			'UUU'		: UserEdit
			'UE'		: Doctor
			'+'		: AddBank 
			'-'		: SubBank 
			'?'		: DispFile(CfgTextPath+'ibmmenu')
		End		
	End
	MakeScores
End
